/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the IdentityMembershipWithDetails type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &IdentityMembershipWithDetails{}

// IdentityMembershipWithDetails struct for IdentityMembershipWithDetails
type IdentityMembershipWithDetails struct {
	GroupIdentifier NullableString `json:"groupIdentifier,omitempty"`
	GroupId         *string        `json:"groupId,omitempty"`
	IdentityId      *string        `json:"identityId,omitempty"`
}

// NewIdentityMembershipWithDetails instantiates a new IdentityMembershipWithDetails object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIdentityMembershipWithDetails() *IdentityMembershipWithDetails {
	this := IdentityMembershipWithDetails{}
	return &this
}

// NewIdentityMembershipWithDetailsWithDefaults instantiates a new IdentityMembershipWithDetails object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIdentityMembershipWithDetailsWithDefaults() *IdentityMembershipWithDetails {
	this := IdentityMembershipWithDetails{}
	return &this
}

// GetGroupIdentifier returns the GroupIdentifier field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityMembershipWithDetails) GetGroupIdentifier() string {
	if o == nil || IsNil(o.GroupIdentifier.Get()) {
		var ret string
		return ret
	}
	return *o.GroupIdentifier.Get()
}

// GetGroupIdentifierOk returns a tuple with the GroupIdentifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityMembershipWithDetails) GetGroupIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.GroupIdentifier.Get(), o.GroupIdentifier.IsSet()
}

// HasGroupIdentifier returns a boolean if a field has been set.
func (o *IdentityMembershipWithDetails) HasGroupIdentifier() bool {
	if o != nil && o.GroupIdentifier.IsSet() {
		return true
	}

	return false
}

// SetGroupIdentifier gets a reference to the given NullableString and assigns it to the GroupIdentifier field.
func (o *IdentityMembershipWithDetails) SetGroupIdentifier(v string) {
	o.GroupIdentifier.Set(&v)
}

// SetGroupIdentifierNil sets the value for GroupIdentifier to be an explicit nil
func (o *IdentityMembershipWithDetails) SetGroupIdentifierNil() {
	o.GroupIdentifier.Set(nil)
}

// UnsetGroupIdentifier ensures that no value is present for GroupIdentifier, not even an explicit nil
func (o *IdentityMembershipWithDetails) UnsetGroupIdentifier() {
	o.GroupIdentifier.Unset()
}

// GetGroupId returns the GroupId field value if set, zero value otherwise.
func (o *IdentityMembershipWithDetails) GetGroupId() string {
	if o == nil || IsNil(o.GroupId) {
		var ret string
		return ret
	}
	return *o.GroupId
}

// GetGroupIdOk returns a tuple with the GroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *IdentityMembershipWithDetails) GetGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.GroupId) {
		return nil, false
	}
	return o.GroupId, true
}

// HasGroupId returns a boolean if a field has been set.
func (o *IdentityMembershipWithDetails) HasGroupId() bool {
	if o != nil && !IsNil(o.GroupId) {
		return true
	}

	return false
}

// SetGroupId gets a reference to the given string and assigns it to the GroupId field.
func (o *IdentityMembershipWithDetails) SetGroupId(v string) {
	o.GroupId = &v
}

// GetIdentityId returns the IdentityId field value if set, zero value otherwise.
func (o *IdentityMembershipWithDetails) GetIdentityId() string {
	if o == nil || IsNil(o.IdentityId) {
		var ret string
		return ret
	}
	return *o.IdentityId
}

// GetIdentityIdOk returns a tuple with the IdentityId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *IdentityMembershipWithDetails) GetIdentityIdOk() (*string, bool) {
	if o == nil || IsNil(o.IdentityId) {
		return nil, false
	}
	return o.IdentityId, true
}

// HasIdentityId returns a boolean if a field has been set.
func (o *IdentityMembershipWithDetails) HasIdentityId() bool {
	if o != nil && !IsNil(o.IdentityId) {
		return true
	}

	return false
}

// SetIdentityId gets a reference to the given string and assigns it to the IdentityId field.
func (o *IdentityMembershipWithDetails) SetIdentityId(v string) {
	o.IdentityId = &v
}

func (o IdentityMembershipWithDetails) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o IdentityMembershipWithDetails) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.GroupIdentifier.IsSet() {
		toSerialize["groupIdentifier"] = o.GroupIdentifier.Get()
	}
	if !IsNil(o.GroupId) {
		toSerialize["groupId"] = o.GroupId
	}
	if !IsNil(o.IdentityId) {
		toSerialize["identityId"] = o.IdentityId
	}
	return toSerialize, nil
}

type NullableIdentityMembershipWithDetails struct {
	value *IdentityMembershipWithDetails
	isSet bool
}

func (v NullableIdentityMembershipWithDetails) Get() *IdentityMembershipWithDetails {
	return v.value
}

func (v *NullableIdentityMembershipWithDetails) Set(val *IdentityMembershipWithDetails) {
	v.value = val
	v.isSet = true
}

func (v NullableIdentityMembershipWithDetails) IsSet() bool {
	return v.isSet
}

func (v *NullableIdentityMembershipWithDetails) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdentityMembershipWithDetails(val *IdentityMembershipWithDetails) *NullableIdentityMembershipWithDetails {
	return &NullableIdentityMembershipWithDetails{value: val, isSet: true}
}

func (v NullableIdentityMembershipWithDetails) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdentityMembershipWithDetails) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
